Index: branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/HeuristicLab.Algorithms.GraphRouting.csproj
===================================================================
--- branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/HeuristicLab.Algorithms.GraphRouting.csproj	(revision 8301)
+++ branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/HeuristicLab.Algorithms.GraphRouting.csproj	(revision 8301)
@@ -0,0 +1,73 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Algorithms.GraphRouting</RootNamespace>
+    <AssemblyName>HeuristicLab.Algorithms.GraphRouting-3.3</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd</PreBuildEvent>
+  </PropertyGroup>
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Plugin.cs.frame
===================================================================
--- branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Plugin.cs.frame	(revision 8301)
+++ branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Plugin.cs.frame	(revision 8301)
@@ -0,0 +1,40 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Algorithms.GraphRouting {
+  /// <summary>
+  /// Plugin class for HeuristicLab.Algorithms.GraphRouting plugin.
+  /// </summary>
+  [Plugin("HeuristicLab.Algorithms.GraphRouting", "Provides different graph routing algorithms.", "3.3.6.$WCREV$")]
+  [PluginFile("HeuristicLab.Algorithms.GraphRouting-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  public class HeuristicLabAlgorithmsGraphRoutingPlugin : PluginBase {
+  }
+}
Index: branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Properties/AssemblyInfo.cs.frame	(revision 8301)
+++ branches/RoutePlanning/HeuristicLab.Algorithms.GraphRouting/3.3/Properties/AssemblyInfo.cs.frame	(revision 8301)
@@ -0,0 +1,55 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Algorithms.GraphRouting")]
+[assembly: AssemblyDescription("HeuristicLab graph routing algorithms")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("D65CF696-8144-47AA-84B4-9F6567D70DB7")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Revision and Build Numbers 
+// by using the '*' as shown below:
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.6.$WCREV$")]
Index: branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning.Test/Program.cs
===================================================================
--- branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning.Test/Program.cs	(revision 8300)
+++ branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning.Test/Program.cs	(revision 8301)
@@ -9,5 +9,5 @@
       //string filepath = @"..\..\OsmTestFiles\testRelation1.osm";
       XmlDataSource xmlDs = new XmlDataSource(filepath);
-      xmlDs.ReadData();
+      //xmlDs.ReadData();
     }
   }
Index: branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutePlanningProblem.cs
===================================================================
--- branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutePlanningProblem.cs	(revision 8300)
+++ branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutePlanningProblem.cs	(revision 8301)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.IO;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -26,4 +27,6 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.RoutePlanning.Osm;
+using HeuristicLab.Problems.RoutePlanning.Osm.Data;
 
 namespace HeuristicLab.Problems.RoutePlanning {
@@ -33,7 +36,10 @@
   public class RoutePlanningProblem : Problem {
     private const string CoordinatesParameterName = "Coordinates";
-    private const string FromParameterName = "From";
-    private const string ToParameterName = "To";
+    private const string SourceParameterName = "Source";
+    private const string TargetParameterName = "Target";
     public string Filename { get; set; }
+
+    IDataSource dataSource;
+    Graph.Graph graph;
 
     #region Parameter Properties
@@ -42,9 +48,9 @@
       get { return (OptionalValueParameter<DoubleMatrix>)Parameters[CoordinatesParameterName]; }
     }
-    public ValueParameter<IntValue> FromParameter {
-      get { return (ValueParameter<IntValue>)Parameters[FromParameterName]; }
+    public ValueParameter<IntValue> SourceParameter {
+      get { return (ValueParameter<IntValue>)Parameters[SourceParameterName]; }
     }
-    public ValueParameter<IntValue> ToParameter {
-      get { return (ValueParameter<IntValue>)Parameters[ToParameterName]; }
+    public ValueParameter<IntValue> TargetParameter {
+      get { return (ValueParameter<IntValue>)Parameters[TargetParameterName]; }
     }
 
@@ -58,12 +64,12 @@
     }
 
-    public IntValue From {
-      get { return FromParameter.Value; }
-      set { FromParameter.Value = value; }
+    public IntValue Source {
+      get { return SourceParameter.Value; }
+      set { SourceParameter.Value = value; }
     }
 
-    public IntValue To {
-      get { return ToParameter.Value; }
-      set { ToParameter.Value = value; }
+    public IntValue Target {
+      get { return TargetParameter.Value; }
+      set { TargetParameter.Value = value; }
     }
 
@@ -86,6 +92,6 @@
     public RoutePlanningProblem() {
       Parameters.Add(new OptionalValueParameter<DoubleMatrix>(CoordinatesParameterName, "The x- and y-Coordinates of the cities."));
-      Parameters.Add(new ValueParameter<IntValue>(FromParameterName, "From."));
-      Parameters.Add(new ValueParameter<IntValue>(ToParameterName, "To."));
+      Parameters.Add(new ValueParameter<IntValue>(SourceParameterName, "Source Node."));
+      Parameters.Add(new ValueParameter<IntValue>(TargetParameterName, "Target Node."));
 
       RegisterEventHandlers();
@@ -96,4 +102,14 @@
     private void RegisterEventHandlers() { }
 
+    public void LoadData(string file) {
+      FileInfo f = new FileInfo(file);
+      dataSource = new XmlDataSource(file);
+      graph = new Graph.Graph(dataSource);
+
+      Name = f.Name;
+
+      OnReset();
+    }
+
   }
 }
Index: branches/RoutePlanning/RoutePlanning.sln
===================================================================
--- branches/RoutePlanning/RoutePlanning.sln	(revision 8300)
+++ branches/RoutePlanning/RoutePlanning.sln	(revision 8301)
@@ -7,4 +7,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.RoutePlanning.Test", "HeuristicLab.Problems.RoutePlanning.Test\HeuristicLab.Problems.RoutePlanning.Test.csproj", "{004241D1-2127-4489-9DFB-9F7707983371}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.GraphRouting", "HeuristicLab.Algorithms.GraphRouting\HeuristicLab.Algorithms.GraphRouting.csproj", "{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}"
 EndProject
 Global
@@ -48,4 +50,14 @@
 		{004241D1-2127-4489-9DFB-9F7707983371}.Release|x86.ActiveCfg = Release|x86
 		{004241D1-2127-4489-9DFB-9F7707983371}.Release|x86.Build.0 = Release|x86
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Release|Any CPU.Build.0 = Release|Any CPU
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Release|Mixed Platforms.ActiveCfg = Release|Any CPU
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Release|Mixed Platforms.Build.0 = Release|Any CPU
+		{4FE72407-6CAA-4F41-9F2D-D45FDA19ED3C}.Release|x86.ActiveCfg = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution